Attribute VB_Name = "DRWTXT"
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved.


'**********************************
'**  Type Definitions:

#If Win32 Then
Public Type RECT
    left As Long
    top As Long
    right As Long
    bottom As Long
End Type
#Else
Public Type RECT
    left As Integer
    top As Integer
    right As Integer
    bottom As Integer
End Type

#End If 'WIN32 Types


'**********************************
'**  Type Definitions:

#If Win32 Then
Public Type SIZE
    cx As Long
    cy As Long
End Type

#End If 'WIN32 Types

''  Text Alignment Options
Public Const TA_NOUPDATECP = 0
Public Const TA_UPDATECP = 1

Public Const TA_LEFT = 0
Public Const TA_RIGHT = 2
Public Const TA_CENTER = 6

Public Const TA_TOP = 0
Public Const TA_BOTTOM = 8
Public Const TA_BASELINE = 24

'' ExtTextOut flags
Public Const ETO_GRAYED = 1
Public Const ETO_OPAQUE = 2
Public Const ETO_CLIPPED = 4

''  DrawText() Format Flags
Public Const DT_TOP = &H0
Public Const DT_LEFT = &H0
Public Const DT_CENTER = &H1
Public Const DT_RIGHT = &H2
Public Const DT_VCENTER = &H4
Public Const DT_BOTTOM = &H8
Public Const DT_WORDBREAK = &H10
Public Const DT_SINGLELINE = &H20
Public Const DT_EXPANDTABS = &H40
Public Const DT_TABSTOP = &H80
Public Const DT_NOCLIP = &H100
Public Const DT_EXTERNALLEADING = &H200
Public Const DT_CALCRECT = &H400
Public Const DT_NOPREFIX = &H800
Public Const DT_INTERNAL = &H1000


'**********************************
'**  Function Declarations:

#If Win32 Then
Public Declare Function DrawText& Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long)
Public Declare Function ExtTextOut& Lib "gdi32" Alias "ExtTextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal wOptions As Long, lpRect As RECT, ByVal lpString As String, ByVal nCount As Long, lpDx As Long)
Public Declare Function GetTabbedTextExtent& Lib "user32" Alias "GetTabbedTextExtentA" (ByVal hDC As Long, ByVal lpString As String, ByVal nCount As Long, ByVal nTabPositions As Long, lpnTabStopPositions As Long)
Public Declare Function GetTextAlign& Lib "gdi32" (ByVal hDC As Long)
Public Declare Function GetTextCharacterExtra& Lib "gdi32" (ByVal hDC As Long)
Public Declare Function GetTextExtentPoint32& Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hDC As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As SIZE)
Public Declare Function InflateRect& Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long)
Public Declare Function SetTextAlign& Lib "gdi32" (ByVal hDC As Long, ByVal wFlags As Long)
Public Declare Function SetTextColor& Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long)
Public Declare Function SetTextJustification& Lib "gdi32" (ByVal hDC As Long, ByVal nBreakExtra As Long, ByVal nBreakCount As Long)
Public Declare Function TabbedTextOut& Lib "user32" Alias "TabbedTextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long, ByVal nTabPositions As Long, lpnTabStopPositions As Long, ByVal nTabOrigin As Long)
Public Declare Function TextOut& Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long)
#Else
Declare Function DrawText% Lib "user" (ByVal hDC%, ByVal lpStr$, ByVal nCount%, lpRect As RECT, ByVal wFormat%)
Declare Function ExtTextOut% Lib "gdi" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal wOptions%, lpRect As Any, ByVal lpString$, ByVal nCount%, lpDx As Any)
Declare Function ExtTextOutBynum% Lib "gdi" Alias "ExtTextOut" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal wOptions%, ByVal lpRect&, ByVal lpString$, ByVal nCount%, ByVal lpDx&)
Declare Function ExtTextOutByrect% Lib "gdi" Alias "ExtTextOut" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal wOptions%, lpRect As RECT, ByVal lpString$, ByVal nCount%, ByVal lpDx&)
Declare Function GetTabbedTextExtent& Lib "gdi" (ByVal hDC%, ByVal lpString$, ByVal nCount%, ByVal nTabPositions%, lpnTabStopPositions%)
Declare Function GetTextAlign% Lib "gdi" (ByVal hDC%)
Declare Function GetTextCharacterExtra% Lib "gdi" (ByVal hDC%)
Declare Function GetTextExtent& Lib "gdi" (ByVal hDC%, ByVal lpString$, ByVal nCount%)
Declare Sub InflateRect Lib "user" (lpRect As RECT, ByVal X%, ByVal Y%)
Declare Function SetTextAlign% Lib "gdi" (ByVal hDC%, ByVal wFlags%)
Declare Function SetTextColor& Lib "gdi" (ByVal hDC%, ByVal crColor&)
Declare Function SetTextJustification% Lib "gdi" (ByVal hDC%, ByVal nBreakExtra%, ByVal nBreakCount%)
Declare Function TabbedTextOut& Lib "user" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal lpString$, ByVal nCount%, ByVal nTabPositions%, lpnTabStopPositions%, ByVal nTabOrigin%)
Declare Function TextOut% Lib "gdi" (ByVal hDC%, ByVal X%, ByVal Y%, ByVal lpString$, ByVal nCount%)
#End If 'WIN32

